import { OnInit, ChangeDetectorRef } from '@angular/core';
import { ClipboardService } from '../clipboard.service';
import { FilterService } from '../filter.service';
import { DataTableUtilsService } from '../data-table-utils.service';
interface CellRenderer {
    cellRender?(row: number, column: number, data: any, columnDefs: Column[]): string;
}
interface Column extends CellRenderer {
    headerName: string;
    field: string;
    width: string;
    sortState?: boolean;
    sort?: boolean;
    filter?: boolean;
    columnFilter?: boolean;
    uniqueFilterValues?: Array<any>;
    selectAll?: boolean;
    selectOne?: boolean;
    isEdit?: boolean;
    showFilter?: boolean;
}
interface TableRow extends CellRenderer {
    filteredOut: boolean;
    filteredOutCommon: boolean;
    pageNo?: number;
    data: Array<any>;
    rowSelect?: boolean;
}
export declare class DataTableComponent implements OnInit {
    private clipboardService;
    private filterService;
    private dataTableService;
    private ref;
    pagination: any;
    private pageSize;
    dragTheme: any;
    theme: any;
    columnDefs: Column[];
    rowData: any;
    rowSelection: boolean;
    commonSearch: boolean;
    isMoving: boolean;
    private clientWidth;
    Moved: Array<any>;
    private math;
    private TableRows;
    FilterRowCount: number;
    TotalPages: number;
    PagedRows: TableRow[];
    CurrentPage: number;
    private InvalidPage;
    FromRecord: number;
    ToRecord: number;
    private FilterData;
    TotalRows: number;
    private FilteredRows;
    contextmenu: boolean;
    contextmenuX: number;
    private previousIndex;
    contextmenuY: number;
    filterMenuX: number;
    private filterMenuY;
    contextMenuData: Array<Array<any>>;
    contextMenuIsEdit: boolean;
    private isDragging;
    rowSizes: number[];
    selectAllRows: boolean;
    createTableData1(filteredData?: Array<any>, currentPage?: number): void;
    private allRows;
    private selectRows;
    checkedRowSelection(event: any, isHeader: any): void;
    private generateUniqueFilters;
    private createColumnFilter;
    private pagedRows;
    private setPagedRow;
    private cellRenderer;
    filter(column: any, text: any): void;
    private applyFilter;
    /**
     * Called If any Unique valiue checkbox use for filter the column.
     * @param filterEventArgs
     */
    checkedColumnFilter(filterEventArgs: any): void;
    updateTotalPageCount(): void;
    nextPage(): void;
    previousPage(): void;
    lastPage(): void;
    firstPage(): void;
    sortColumn(column: any): void;
    private applySort;
    private sortFunction;
    dragEnded(event: any): void;
    drop(event: any): void;
    dropRow(event: any): void;
    valueChanged(changeValue: any): void;
    private selectedRowsCount;
    showContextMenu(event: any): void;
    private getCommonFiliterIndex;
    /**
     * On Key up common filter.
     * @param text: String to be searched across the table data.
     */
    onCommonFilter(text: any): void;
    hasData(column: any): boolean;
    unSelectRows(): void;
    onSelecting(rowCount: any, columnCount: any, cell: any, $event: any): void;
    onClick(rowCount: any, columnCount: any, cell: any, $event: any): void;
    onDragStart(row: any, column: any, $event: any): void;
    private selectedRowsColumns;
    onDragEnd(row: any, column: any, $event: any): void;
    private animateRows;
    swapped(event: any): void;
    onContextMenuOff(): void;
    deleteData(data: Array<Array<any>>): void;
    pasteData(pasteData: Array<Array<any>>): void;
    onCtrlV(): void;
    onCtrlC(): void;
    toggleFilter(column: any, event: any): void;
    onRowSizeChange($event: any, value: any): void;
    private tableDraw;
    constructor(clipboardService: ClipboardService, filterService: FilterService, dataTableService: DataTableUtilsService, ref: ChangeDetectorRef);
    ngOnInit(): void;
}
export {};
